/*
 * WhatsNew.java
 *
 * Created on March 12, 2008, 9:14 PM
 */

package anecho.JamochaMUD;

/**
 *
 * This dialogue will show the most recent changes/fixes for this version of JamochaMUD.
 * 
 * @author  jeffnik
 * @version $Id: WhatsNew.java,v 1.11 2008/11/16 21:42:44 jeffnik Exp $
 */
public class WhatsNew extends javax.swing.JDialog {
    
    /** Creates new form WhatsNew
     * @param parent The frame that will be parent to this dialogue
     * @param modal Indicate whether this dialogue should be modal or not
     */
    public WhatsNew(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        messageText.setText("JamochaMUD version " + AboutBox.verNum + " released " + AboutBox.buildNum + "\n" +
                "- 0000063: [Main Program] Access MudLists (MUDConnector) lists (jeffnik) - resolved.\n" +
                "- 0000218: [User Interface] Poor interface design on World Connector (jeffnik) - resolved.\n" +
                "- 0000220: [User Interface] MUD address and port reversed (jeffnik) - resolved.\n" +
                "- 0000217: [User Interface] User does not receive activity indication when minimized (jeffnik) - resolved.\n"
                );
        
        if (JMConfig.getInstance().getJMboolean(JMConfig.SHOWNEW)) {
            dontShowCB.setSelected(false);
        } else {
            dontShowCB.setSelected(true);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        dontShowCB = new javax.swing.JCheckBox();
        okayButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        messageText = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("What's new!");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeHandler(evt);
            }
        });
        getContentPane().setLayout(new java.awt.GridBagLayout());

        dontShowCB.setText("Don't show this dialogue again.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 5);
        getContentPane().add(dontShowCB, gridBagConstraints);

        okayButton.setText("Okay");
        okayButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okayButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 5, 5);
        getContentPane().add(okayButton, gridBagConstraints);

        jLabel1.setText("Changes that have been made since the last version of JamochaMUD:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 2, 5);
        getContentPane().add(jLabel1, gridBagConstraints);

        messageText.setColumns(20);
        messageText.setEditable(false);
        messageText.setLineWrap(true);
        messageText.setRows(10);
        messageText.setWrapStyleWord(true);
        jScrollPane1.setViewportView(messageText);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 5);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okayButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okayButtonActionPerformed
        closeAndSave();
    }//GEN-LAST:event_okayButtonActionPerformed

    private void closeHandler(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeHandler
        closeAndSave();
    }//GEN-LAST:event_closeHandler
    
    /**
     * Saves any required settings before closing this dialogue
     */
    private void closeAndSave() {
        if (DEBUG) {
            System.err.println("WhatsNew.closeAndSave called.");
        }
        
        this.setVisible(false);
        
        // Save any required settings
        final JMConfig settings = JMConfig.getInstance();
        boolean showNew = false;
        
        if (!dontShowCB.isSelected()) {
            showNew = true;
        }
        
        // Save whether this dialogue should automatically appear
        // when new versions are distributed
        settings.setJMboolean(JMConfig.SHOWNEW, String.valueOf(showNew));
        
        // Dispose of the dialogue
        this.dispose();
    }
    
    /**
     * Enabled and disables debugging output
     */
    private static final boolean DEBUG = false;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox dontShowCB;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea messageText;
    private javax.swing.JButton okayButton;
    // End of variables declaration//GEN-END:variables
    
}
