/* This PlugIn strips the [fmcl] indicators
 * from FurryMUCK locations, and places them
 * as the window'start title
 */

package anecho.JamochaMUD.plugins;

import anecho.JamochaMUD.JMConfig;
// import anecho.JamochaMUD.JMUD;
import anecho.JamochaMUD.MuSocket;

import java.util.*;

// These import statements are specific to this plug-in
// import MuckConn;
// import MuckMain;

/**
 * This PlugIn strips the [fmcl] indicators
 * from FurryMUCK locations, and places them
 * as the window'start title
 * @version $Id: FBLocationPlugIn.java,v 1.9 2008/03/08 16:25:42 jeffnik Exp $
 * @author Jeff Robinson
 */

public class FBLocationPlugIn implements PlugInterface {

    // public void setLoader(Object o) {
    // }

    /**
     * The main JamochaMUD settings.  Having this variable passed
     * instead of dynamically picking it up may be a "waste of
     * resources" now that JMConfig has become a singleton.
     * Fix Me XXX
     */
    // private JMConfig settings;
    transient private boolean active = false;

    /**
     * Set the variable for the JamochaMUD settings.  This
     * method may need to be deprecated.  Fix Me XXX
     * @param mainSettings Main JamochaMUD settings.
     */
    public void setSettings(final JMConfig mainSettings) {
//        this.settings = mainSettings;
    }

    /**
     * 
     * @return 
     */
    public String plugInName() {
        return java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("FurryMUCK_Location_Plug-in");
    }

    /**
     * 
     * @return 
     */
    public String plugInDescription() {
        return java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("This_PlugIn_strips_the_[fmcl]_indicators_from_FurryMUCK_locations,_and_places_them_as_the_window's_title.");
    }

    /**
     * 
     * @return 
     */
    public String plugInType() {
        return java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("Output");
    }

    /**
     * 
     * @param jamochaString 
     * @param mSock 
     * @return 
     */
    public String plugMain(final String jamochaString, final MuSocket mSock) {
        // When we receive a string beginning with [fmcl],
        // we'll parse it down to get the location'start name
        // and then use that as the title for the main window

        String retString;

        if (jamochaString.startsWith(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("[fmcl"))) {
            // We have a qualifying string

            // Tokenize the string
            final StringTokenizer mainString = new StringTokenizer(jamochaString);
            final StringBuffer newTitle = new StringBuffer("");
            String finalTitle;

            // Discard the first two tokens
            mainString.nextToken();
            mainString.nextToken();

            while (mainString.hasMoreTokens()) {
                newTitle.append(mainString.nextToken());
                newTitle.append(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("_"));
            }

            // Now remove any nasty 'escapes' that may be in there
            int start, finish;
            String temp;
            
            while ((newTitle.toString()).indexOf('\u001b') > 0) {
                // Remove the escape
                temp = newTitle.toString();
                start = temp.indexOf('\u001b');
                // finish = temp.indexOf(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("m"), start);
                finish = temp.indexOf('m', start);
                // newTitle = new StringBuffer(temp.substring(0, start) + temp.substring(finish));
                newTitle.setLength(0);
                newTitle.append(temp.substring(0, start));
                newTitle.append(temp.substring(finish));

                if (DEBUG) {
                    System.err.println(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("_") + newTitle);
                }
            }

            // finalTitle = new String(newTitle.toString());
            finalTitle = newTitle.toString();
            finalTitle.trim();

            if (mSock != null) {
                mSock.setMUName(finalTitle);
            }
            retString = "";
        } else {
            retString = jamochaString;
        }

        return retString;
    }

    /** This plug-in has no properties to display */
    public void plugInProperties() {
        // This plug-in currently has no properties to display.
    }

    /** Call to initialise any functions required immediately when the plug-in is loaded. */
    public void initialiseAtLoad(){
        // this.settings = JMConfig.getInstance();
    }

    public void setAtHalt(){
        // We'll restore the title of the main window
        // back to 'JamochaMUD' again.
        // Fix this XXX
        // MuckMain.muckMainTitle = new String("JamochaMUD");
        // MuckMain.setWindowTitle();
    }

    /**
     * We don't require a directory for our settings
     * @return 
     */
    public boolean haveConfig() {
        return false;
    }

    /**
     * We have no editable properties
     * @return 
     */
    public boolean hasProperties() {
        return false;
    }

    public void activate() {
        active = true;
    }

    public void deactivate() {
        active = false;
    }

    /**
     * 
     * @return 
     */
    public boolean isActive() {
        return active;
    }
    
    /**
     * Allows enabling and disabling of debugging comments
     */
    private static final boolean DEBUG = false;
    
}
